# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

FEAT_METADATA = Metadata(
    id="c4cf0dfc9152f828d4ff0df1965cfc415d18e4c5.boutiques",
    name="feat",
    package="fsl",
    container_image_tag="brainlife/fsl:6.0.4-patched2",
)


FeatParameters = typing.TypedDict('FeatParameters', {
    "__STYX_TYPE__": typing.Literal["feat"],
    "design_file": InputPathType,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "feat": feat_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
        "feat": feat_outputs,
    }.get(t)


class FeatOutputs(typing.NamedTuple):
    """
    Output object returned when calling `feat(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    output_dir: OutputPathType
    """Output directory containing all results from FEAT"""


def feat_params(
    design_file: InputPathType,
) -> FeatParameters:
    """
    Build parameters.
    
    Args:
        design_file: FEAT design file (e.g. design.fsf).
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "feat",
        "design_file": design_file,
    }
    return params


def feat_cargs(
    params: FeatParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("feat")
    cargs.append(execution.input_file(params.get("design_file")))
    return cargs


def feat_outputs(
    params: FeatParameters,
    execution: Execution,
) -> FeatOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = FeatOutputs(
        root=execution.output_file("."),
        output_dir=execution.output_file("design.feat"),
    )
    return ret


def feat_execute(
    params: FeatParameters,
    execution: Execution,
) -> FeatOutputs:
    """
    fMRI Expert Analysis Tool.
    
    Author: FMRIB Analysis Group, University of Oxford
    
    URL: https://fsl.fmrib.ox.ac.uk/fsl/fslwiki
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `FeatOutputs`).
    """
    params = execution.params(params)
    cargs = feat_cargs(params, execution)
    ret = feat_outputs(params, execution)
    execution.run(cargs)
    return ret


def feat(
    design_file: InputPathType,
    runner: Runner | None = None,
) -> FeatOutputs:
    """
    fMRI Expert Analysis Tool.
    
    Author: FMRIB Analysis Group, University of Oxford
    
    URL: https://fsl.fmrib.ox.ac.uk/fsl/fslwiki
    
    Args:
        design_file: FEAT design file (e.g. design.fsf).
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `FeatOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(FEAT_METADATA)
    params = feat_params(
        design_file=design_file,
    )
    return feat_execute(params, execution)


__all__ = [
    "FEAT_METADATA",
    "FeatOutputs",
    "FeatParameters",
    "feat",
    "feat_params",
]
