# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

FILMBABESCRIPT_METADATA = Metadata(
    id="c482f1ace2d9ca2fee7c3ed712be29e7f1ae595a.boutiques",
    name="filmbabescript",
    package="fsl",
    container_image_tag="brainlife/fsl:6.0.4-patched2",
)


FilmbabescriptParameters = typing.TypedDict('FilmbabescriptParameters', {
    "__STYX_TYPE__": typing.Literal["filmbabescript"],
    "feat_dir": str,
    "flobs_dir": str,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "filmbabescript": filmbabescript_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
    }.get(t)


class FilmbabescriptOutputs(typing.NamedTuple):
    """
    Output object returned when calling `filmbabescript(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def filmbabescript_params(
    feat_dir: str,
    flobs_dir: str,
) -> FilmbabescriptParameters:
    """
    Build parameters.
    
    Args:
        feat_dir: Input FEAT directory.
        flobs_dir: Input FLOBs directory.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "filmbabescript",
        "feat_dir": feat_dir,
        "flobs_dir": flobs_dir,
    }
    return params


def filmbabescript_cargs(
    params: FilmbabescriptParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("filmbabescript")
    cargs.append(params.get("feat_dir"))
    cargs.append(params.get("flobs_dir"))
    return cargs


def filmbabescript_outputs(
    params: FilmbabescriptParameters,
    execution: Execution,
) -> FilmbabescriptOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = FilmbabescriptOutputs(
        root=execution.output_file("."),
    )
    return ret


def filmbabescript_execute(
    params: FilmbabescriptParameters,
    execution: Execution,
) -> FilmbabescriptOutputs:
    """
    A tool/script for processing FEAT directories and FLOBs directories.
    
    Author: FMRIB Analysis Group, University of Oxford
    
    URL: https://fsl.fmrib.ox.ac.uk/fsl/fslwiki
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `FilmbabescriptOutputs`).
    """
    params = execution.params(params)
    cargs = filmbabescript_cargs(params, execution)
    ret = filmbabescript_outputs(params, execution)
    execution.run(cargs)
    return ret


def filmbabescript(
    feat_dir: str,
    flobs_dir: str,
    runner: Runner | None = None,
) -> FilmbabescriptOutputs:
    """
    A tool/script for processing FEAT directories and FLOBs directories.
    
    Author: FMRIB Analysis Group, University of Oxford
    
    URL: https://fsl.fmrib.ox.ac.uk/fsl/fslwiki
    
    Args:
        feat_dir: Input FEAT directory.
        flobs_dir: Input FLOBs directory.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `FilmbabescriptOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(FILMBABESCRIPT_METADATA)
    params = filmbabescript_params(
        feat_dir=feat_dir,
        flobs_dir=flobs_dir,
    )
    return filmbabescript_execute(params, execution)


__all__ = [
    "FILMBABESCRIPT_METADATA",
    "FilmbabescriptOutputs",
    "FilmbabescriptParameters",
    "filmbabescript",
    "filmbabescript_params",
]
