# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

FSLORIENT_METADATA = Metadata(
    id="0251bdcfb633b8902b0c6aefc450822d880b30fe.boutiques",
    name="fslorient",
    package="fsl",
    container_image_tag="brainlife/fsl:6.0.4-patched2",
)


FslorientParameters = typing.TypedDict('FslorientParameters', {
    "__STYX_TYPE__": typing.Literal["fslorient"],
    "get_orient": bool,
    "get_sform": bool,
    "get_qform": bool,
    "set_sform": typing.NotRequired[str | None],
    "set_qform": typing.NotRequired[str | None],
    "set_sform_code": typing.NotRequired[str | None],
    "set_qform_code": typing.NotRequired[str | None],
    "get_qform_code": bool,
    "get_sform_code": bool,
    "copy_qform_to_sform": bool,
    "copy_sform_to_qform": bool,
    "delete_orient": bool,
    "force_neurological": bool,
    "force_radiological": bool,
    "swap_orient": bool,
    "filename": InputPathType,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "fslorient": fslorient_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
    }.get(t)


class FslorientOutputs(typing.NamedTuple):
    """
    Output object returned when calling `fslorient(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def fslorient_params(
    filename: InputPathType,
    get_orient: bool = False,
    get_sform: bool = False,
    get_qform: bool = False,
    set_sform: str | None = None,
    set_qform: str | None = None,
    set_sform_code: str | None = None,
    set_qform_code: str | None = None,
    get_qform_code: bool = False,
    get_sform_code: bool = False,
    copy_qform_to_sform: bool = False,
    copy_sform_to_qform: bool = False,
    delete_orient: bool = False,
    force_neurological: bool = False,
    force_radiological: bool = False,
    swap_orient: bool = False,
) -> FslorientParameters:
    """
    Build parameters.
    
    Args:
        filename: Filename of the image to operate on (e.g. img.nii.gz).
        get_orient: Prints FSL left-right orientation.
        get_sform: Prints the 16 elements of the sform matrix.
        get_qform: Prints the 16 elements of the qform matrix.
        set_sform: Sets the 16 elements of the sform matrix.
        set_qform: Sets the 16 elements of the qform matrix.
        set_sform_code: Sets sform integer code.
        set_qform_code: Sets qform integer code.
        get_qform_code: Prints the qform integer code.
        get_sform_code: Prints the sform integer code.
        copy_qform_to_sform: Sets the sform equal to the qform - code and\
            matrix.
        copy_sform_to_qform: Sets the qform equal to the sform - code and\
            matrix.
        delete_orient: Removes orient info from header.
        force_neurological: Makes FSL neurological header - not Analyze.
        force_radiological: Makes FSL radiological header.
        swap_orient: Swaps FSL radiological and FSL neurological.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "fslorient",
        "get_orient": get_orient,
        "get_sform": get_sform,
        "get_qform": get_qform,
        "get_qform_code": get_qform_code,
        "get_sform_code": get_sform_code,
        "copy_qform_to_sform": copy_qform_to_sform,
        "copy_sform_to_qform": copy_sform_to_qform,
        "delete_orient": delete_orient,
        "force_neurological": force_neurological,
        "force_radiological": force_radiological,
        "swap_orient": swap_orient,
        "filename": filename,
    }
    if set_sform is not None:
        params["set_sform"] = set_sform
    if set_qform is not None:
        params["set_qform"] = set_qform
    if set_sform_code is not None:
        params["set_sform_code"] = set_sform_code
    if set_qform_code is not None:
        params["set_qform_code"] = set_qform_code
    return params


def fslorient_cargs(
    params: FslorientParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("fslorient")
    if params.get("get_orient"):
        cargs.append("-getorient")
    if params.get("get_sform"):
        cargs.append("-getsform")
    if params.get("get_qform"):
        cargs.append("-getqform")
    if params.get("set_sform") is not None:
        cargs.extend([
            "-setsform",
            params.get("set_sform")
        ])
    if params.get("set_qform") is not None:
        cargs.extend([
            "-setqform",
            params.get("set_qform")
        ])
    if params.get("set_sform_code") is not None:
        cargs.extend([
            "-setsformcode",
            params.get("set_sform_code")
        ])
    if params.get("set_qform_code") is not None:
        cargs.extend([
            "-setqformcode",
            params.get("set_qform_code")
        ])
    if params.get("get_qform_code"):
        cargs.append("-getqformcode")
    if params.get("get_sform_code"):
        cargs.append("-getsformcode")
    if params.get("copy_qform_to_sform") or params.get("copy_sform_to_qform"):
        cargs.append(("-copyqform2sform" if params.get("copy_qform_to_sform") else "") + ("-copysform2qform" if params.get("copy_sform_to_qform") else ""))
    if params.get("delete_orient"):
        cargs.append("-deleteorient")
    if params.get("force_neurological"):
        cargs.append("-forceneurological")
    if params.get("force_radiological"):
        cargs.append("-forceradiological")
    if params.get("swap_orient"):
        cargs.append("-swaporient")
    cargs.append(execution.input_file(params.get("filename")))
    return cargs


def fslorient_outputs(
    params: FslorientParameters,
    execution: Execution,
) -> FslorientOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = FslorientOutputs(
        root=execution.output_file("."),
    )
    return ret


def fslorient_execute(
    params: FslorientParameters,
    execution: Execution,
) -> FslorientOutputs:
    """
    FSL tool to manipulate NIfTI header orientation information.
    
    Author: FMRIB Analysis Group, University of Oxford
    
    URL: https://fsl.fmrib.ox.ac.uk/fsl/fslwiki
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `FslorientOutputs`).
    """
    params = execution.params(params)
    cargs = fslorient_cargs(params, execution)
    ret = fslorient_outputs(params, execution)
    execution.run(cargs)
    return ret


def fslorient(
    filename: InputPathType,
    get_orient: bool = False,
    get_sform: bool = False,
    get_qform: bool = False,
    set_sform: str | None = None,
    set_qform: str | None = None,
    set_sform_code: str | None = None,
    set_qform_code: str | None = None,
    get_qform_code: bool = False,
    get_sform_code: bool = False,
    copy_qform_to_sform: bool = False,
    copy_sform_to_qform: bool = False,
    delete_orient: bool = False,
    force_neurological: bool = False,
    force_radiological: bool = False,
    swap_orient: bool = False,
    runner: Runner | None = None,
) -> FslorientOutputs:
    """
    FSL tool to manipulate NIfTI header orientation information.
    
    Author: FMRIB Analysis Group, University of Oxford
    
    URL: https://fsl.fmrib.ox.ac.uk/fsl/fslwiki
    
    Args:
        filename: Filename of the image to operate on (e.g. img.nii.gz).
        get_orient: Prints FSL left-right orientation.
        get_sform: Prints the 16 elements of the sform matrix.
        get_qform: Prints the 16 elements of the qform matrix.
        set_sform: Sets the 16 elements of the sform matrix.
        set_qform: Sets the 16 elements of the qform matrix.
        set_sform_code: Sets sform integer code.
        set_qform_code: Sets qform integer code.
        get_qform_code: Prints the qform integer code.
        get_sform_code: Prints the sform integer code.
        copy_qform_to_sform: Sets the sform equal to the qform - code and\
            matrix.
        copy_sform_to_qform: Sets the qform equal to the sform - code and\
            matrix.
        delete_orient: Removes orient info from header.
        force_neurological: Makes FSL neurological header - not Analyze.
        force_radiological: Makes FSL radiological header.
        swap_orient: Swaps FSL radiological and FSL neurological.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `FslorientOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(FSLORIENT_METADATA)
    params = fslorient_params(
        get_orient=get_orient,
        get_sform=get_sform,
        get_qform=get_qform,
        set_sform=set_sform,
        set_qform=set_qform,
        set_sform_code=set_sform_code,
        set_qform_code=set_qform_code,
        get_qform_code=get_qform_code,
        get_sform_code=get_sform_code,
        copy_qform_to_sform=copy_qform_to_sform,
        copy_sform_to_qform=copy_sform_to_qform,
        delete_orient=delete_orient,
        force_neurological=force_neurological,
        force_radiological=force_radiological,
        swap_orient=swap_orient,
        filename=filename,
    )
    return fslorient_execute(params, execution)


__all__ = [
    "FSLORIENT_METADATA",
    "FslorientOutputs",
    "FslorientParameters",
    "fslorient",
    "fslorient_params",
]
